# coding: utf-8

"""
Copyright 2016 SmartBear Software

    Licensed under the Apache License, Version 2.0 (the "License");
    you may not use this file except in compliance with the License.
    You may obtain a copy of the License at

        http://www.apache.org/licenses/LICENSE-2.0

    Unless required by applicable law or agreed to in writing, software
    distributed under the License is distributed on an "AS IS" BASIS,
    WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
    See the License for the specific language governing permissions and
    limitations under the License.

    Ref: https://github.com/swagger-api/swagger-codegen
"""

from pprint import pformat
from six import iteritems


class Query(object):
    """
    NOTE: This class is auto generated by the swagger code generator program.
    Do not edit the class manually.
    """
    def __init__(self):
        """
        Query - a model defined in Swagger

        :param dict swaggerTypes: The key is attribute name
                                  and the value is attribute type.
        :param dict attributeMap: The key is attribute name
                                  and the value is json key in definition.
        """
        self.swagger_types = {
            'traversable_again': 'bool',
            'raw': 'bool',
            'empty': 'bool'
        }

        self.attribute_map = {
            'traversable_again': 'traversableAgain',
            'raw': 'raw',
            'empty': 'empty'
        }

        self._traversable_again = None
        self._raw = None
        self._empty = None

    @property
    def traversable_again(self):
        """
        Gets the traversable_again of this Query.


        :return: The traversable_again of this Query.
        :rtype: bool
        """
        return self._traversable_again

    @traversable_again.setter
    def traversable_again(self, traversable_again):
        """
        Sets the traversable_again of this Query.


        :param traversable_again: The traversable_again of this Query.
        :type: bool
        """
        self._traversable_again = traversable_again

    @property
    def raw(self):
        """
        Gets the raw of this Query.


        :return: The raw of this Query.
        :rtype: bool
        """
        return self._raw

    @raw.setter
    def raw(self, raw):
        """
        Sets the raw of this Query.


        :param raw: The raw of this Query.
        :type: bool
        """
        self._raw = raw

    @property
    def empty(self):
        """
        Gets the empty of this Query.


        :return: The empty of this Query.
        :rtype: bool
        """
        return self._empty

    @empty.setter
    def empty(self, empty):
        """
        Sets the empty of this Query.


        :param empty: The empty of this Query.
        :type: bool
        """
        self._empty = empty

    def to_dict(self):
        """
        Returns the model properties as a dict
        """
        result = {}

        for attr, _ in iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """
        Returns the string representation of the model
        """
        return pformat(self.to_dict())

    def __repr__(self):
        """
        For `print` and `pprint`
        """
        return self.to_str()

    def __eq__(self, other):
        """
        Returns true if both objects are equal
        """
        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """
        Returns true if both objects are not equal
        """
        return not self == other

