# coding: utf-8

"""
Copyright 2016 SmartBear Software

    Licensed under the Apache License, Version 2.0 (the "License");
    you may not use this file except in compliance with the License.
    You may obtain a copy of the License at

        http://www.apache.org/licenses/LICENSE-2.0

    Unless required by applicable law or agreed to in writing, software
    distributed under the License is distributed on an "AS IS" BASIS,
    WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
    See the License for the specific language governing permissions and
    limitations under the License.

    Ref: https://github.com/swagger-api/swagger-codegen
"""

from pprint import pformat
from six import iteritems


class SystemInformationResponse(object):
    """
    NOTE: This class is auto generated by the swagger code generator program.
    Do not edit the class manually.
    """
    def __init__(self):
        """
        SystemInformationResponse - a model defined in Swagger

        :param dict swaggerTypes: The key is attribute name
                                  and the value is attribute type.
        :param dict attributeMap: The key is attribute name
                                  and the value is json key in definition.
        """
        self.swagger_types = {
            'subject_id': 'str',
            'organization': 'str',
            'name': 'str',
            'version': 'str',
            'dependencies': 'list[SystemInformationResponseDependency]'
        }

        self.attribute_map = {
            'subject_id': 'subjectId',
            'organization': 'organization',
            'name': 'name',
            'version': 'version',
            'dependencies': 'dependencies'
        }

        self._subject_id = None
        self._organization = None
        self._name = None
        self._version = None
        self._dependencies = None

    @property
    def subject_id(self):
        """
        Gets the subject_id of this SystemInformationResponse.


        :return: The subject_id of this SystemInformationResponse.
        :rtype: str
        """
        return self._subject_id

    @subject_id.setter
    def subject_id(self, subject_id):
        """
        Sets the subject_id of this SystemInformationResponse.


        :param subject_id: The subject_id of this SystemInformationResponse.
        :type: str
        """
        self._subject_id = subject_id

    @property
    def organization(self):
        """
        Gets the organization of this SystemInformationResponse.


        :return: The organization of this SystemInformationResponse.
        :rtype: str
        """
        return self._organization

    @organization.setter
    def organization(self, organization):
        """
        Sets the organization of this SystemInformationResponse.


        :param organization: The organization of this SystemInformationResponse.
        :type: str
        """
        self._organization = organization

    @property
    def name(self):
        """
        Gets the name of this SystemInformationResponse.


        :return: The name of this SystemInformationResponse.
        :rtype: str
        """
        return self._name

    @name.setter
    def name(self, name):
        """
        Sets the name of this SystemInformationResponse.


        :param name: The name of this SystemInformationResponse.
        :type: str
        """
        self._name = name

    @property
    def version(self):
        """
        Gets the version of this SystemInformationResponse.


        :return: The version of this SystemInformationResponse.
        :rtype: str
        """
        return self._version

    @version.setter
    def version(self, version):
        """
        Sets the version of this SystemInformationResponse.


        :param version: The version of this SystemInformationResponse.
        :type: str
        """
        self._version = version

    @property
    def dependencies(self):
        """
        Gets the dependencies of this SystemInformationResponse.


        :return: The dependencies of this SystemInformationResponse.
        :rtype: list[SystemInformationResponseDependency]
        """
        return self._dependencies

    @dependencies.setter
    def dependencies(self, dependencies):
        """
        Sets the dependencies of this SystemInformationResponse.


        :param dependencies: The dependencies of this SystemInformationResponse.
        :type: list[SystemInformationResponseDependency]
        """
        self._dependencies = dependencies

    def to_dict(self):
        """
        Returns the model properties as a dict
        """
        result = {}

        for attr, _ in iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """
        Returns the string representation of the model
        """
        return pformat(self.to_dict())

    def __repr__(self):
        """
        For `print` and `pprint`
        """
        return self.to_str()

    def __eq__(self, other):
        """
        Returns true if both objects are equal
        """
        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """
        Returns true if both objects are not equal
        """
        return not self == other

